<template>
  <div>
    <b-jumbotron>
      <template #header>Play game</template>
      <template #lead> Lottoland Code Challenge </template>
      <div class="text-right">
        <h3><nuxt-link id="btn_to_index" to="/statistics">Go general statistics</nuxt-link></h3>
      </div>
      <hr class="my-4" />
      <Table :items="gameResult" />
      <h3>Played games: {{ counter }}</h3>
      <div class="text-right">
        <b-button
          class="formButton"
          variant="outline-primary"
          size="lg"
          @click.stop="startGame()"
          >Play</b-button
        >
        <b-button
          class="formButton"
          variant="outline-secondary"
          size="lg"
          @click.stop="resetGame()"
          >Restart game</b-button
        >
      </div>
    </b-jumbotron>
  </div>
</template>

<script>
import { mapActions } from 'vuex'
import Table from '@/components/Table'

export default {
  name: 'MainGame',
  components: {
    Table
  },
  async asyncData({ $axios }) {},
  data() {
    return {
      counter: 0
    }
  },
  computed: {
    gameResult: {
      get() {
        return this.$store.state.game.gameResult || []
      },
      set(value) {
        this.$store.commit('game/setResult', value)
      }
    }
  },
  async beforeMount() {
    await this.$axios.$post('/token', { data: {} }).then((result) => {
      this.setToken(result.token)
    })
  },
  methods: {
    ...mapActions({
      setToken: 'app/setToken',
      setResult: 'game/setResult'
    }),
    async startGame() {
      this.counter++
      await this.$axios.$post('/games', { data: {} }).then((result) => {
        this.setResult(result.rounds_list)
      })
    },
    resetGame() {
      this.counter = 0
      this.$store.dispatch('game/empty')
    }
  }
}
</script>
